<?php

namespace Drupal\style_management\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

use Drupal\Core\State\StateInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class ScssFilesForm.
 */
class ScssFilesForm extends ConfigFormBase {

  /**
   * Load State in Class.
   *
   * @var \Drupal\Core\State\StateInterface
   */
  protected $state;

  /**
   * ScssFilesForm constructor.
   *
   * @param \Drupal\Core\State\StateInterface $state
   *   Load Stete Interface from service.
   */
  public function __construct(StateInterface $state) {
    $this->state = $state;
  }

  /**
   * Load info from Container.
   *
   * @param object|\Symfony\Component\DependencyInjection\ContainerInterface $container
   *   The container.
   */
  public static function create(ContainerInterface $container) {
    return new static (
      $container->get('state')
    );
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'style_management.scssfiles',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'scss_files_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {

    // Get current config.
    $config = $this->state->get('style_management.config', '');

    if (isset($config['processable_file']) && !empty($config['processable_file'])) {
      $processable_file = $config['processable_file'];
      if (count($processable_file) > 0) {
        if (isset($processable_file['scss']) && !empty($processable_file['scss'])) {
          $less = $processable_file['scss'];
          if (count($less) > 0) {
            // @TODO dpm($scss);.
          }
        }
      }
    }
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);

    $this->config('style_management.scssfiles')
      ->save();
  }

}
